/* 
 * Copyright (C) 2017 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/gpl-3.0.txt
 *
 */
package com.frojasg1.textcrypt.startapp;

import com.frojasg1.general.GenericFileFunctions;
import com.frojasg1.general.desktop.dialogs.implementation.StaticDesktopDialogsWrapper;
import com.frojasg1.general.desktop.files.FileFunctions;
import com.frojasg1.general.desktop.generic.DesktopGenericFunctions;
import com.frojasg1.general.exceptions.ConfigurationException;
import com.frojasg1.generic.languages.ObtainAvailableLanguages_base;
import com.frojasg1.textcrypt.application.LicenseJDialog;
import com.frojasg1.textcrypt.application.Main;
import com.frojasg1.textcrypt.application.configuration.ApplicationConfiguration;
import java.awt.Component;
import java.io.File;
import java.io.IOException;
import javax.swing.JOptionPane;

/**
 *
 * @author Usuario
 */
public class OpenConfiguration
{
	protected static final String MAIN_APP_CONF_FOLDER = FileFunctions.convertFolderSeparator( ".frojasg1.apps/ChessPDFBrowser/v1.0" );
//	protected static final String PREVIOUS_MAIN_APP_CONF_FOLDER = FileFunctions.convertFolderSeparator( "frojasg1.apps/FileEncoderApplication/Configuration" );
//	protected static final String APP_CONF_FILENAME = "GlobalConfiguration.properties";

//	protected static final String PREVIOUS_ENCRYPTION_LIBRARY_CONF_FOLDER = FileFunctions.convertFolderSeparator( "frojasg1.apps/FileEncoder/EncryptingConfigurations" );
//	protected static final String ENCRYPTION_LIBRARY_CONF_FOLDER = FileFunctions.convertFolderSeparator( ".frojasg1.apps/FileEncoder/v1.2/EncryptingConfigurations" );

//	protected static final String ENCRYPTING_CONF_BASE_FILENAME = "EncryptingConfiguration";

	protected static final String HOME_FOLDER = System.getProperty("user.home");
	
	protected Component _parent = null;
	protected boolean _createdEncryptingConfigurations = false;

	protected boolean _hasToImport = false;

//	public OpenConfiguration( Component parent )
	public OpenConfiguration( ) throws ConfigurationException
	{
//		_parent = parent;
		openBasicConfiguration();

		_hasToImport = hasToImport();
	}

	public void setParent( Component parent )
	{
		_parent = parent;
	}

	public boolean getHasToImport()
	{
		return( _hasToImport );
	}

	protected final boolean hasToImport()
	{
//		String oldDir = getFolderName( PREVIOUS_MAIN_APP_CONF_FOLDER );
//		String newDir = getFolderName( MAIN_APP_CONF_FOLDER );

//		return( checkOldAndNewFolder( oldDir, newDir ) );
		return( false );
	}

	public boolean importConfigurationIfNecessary() throws ConfigurationException, IOException
	{
		openOtherConfiguration();
/*
		boolean result = false;
		if( FileFunctions.isFile(HOME_FOLDER + FileFunctions.DIR_SEPARATOR + MAIN_APP_CONF_CONFIGURATION_FOLDER + FileFunctions.DIR_SEPARATOR +
									APP_CONF_FILENAME ) )
		{
			openOtherConfiguration();
		}
		else
		{
			Splash.instance().setCurrentActivityFromLabel( Splash.CONF_IMPORTING_CONFIGURATION );
			_createdEncryptingConfigurations = false;

			try
			{
				if( checkAndImportConfiguration() )
				{
					openOtherConfiguration();
					String message = StringsConfiguration.instance().M_getStrParamConfiguration( StringsConfiguration.CONF_HAS_BEEN_IMPORTED ) + "\n" +
										StringsConfiguration.instance().M_getStrParamConfiguration( StringsConfiguration.CONF_INDEPENDENT_CONF );

					if( _createdEncryptingConfigurations )
						message += "\n\n" + StringsConfiguration.instance().M_getStrParamConfiguration( StringsConfiguration.CONF_ENCRYPTING_CONF_HAS_BEEN_CREATED );

					String title = StringsConfiguration.instance().M_getStrParamConfiguration( StringsConfiguration.CONF_NOTICE );

					GenericFunctions.instance().getDialogsWrapper().showMessageDialog( DesktopDialogsWrapper.instance().createViewComponent(_parent),
																						message, title,	DialogsWrapper.INFORMATION_MESSAGE );

					result = true;
				}
				else
				{
					openOtherConfiguration();
				}
			}
			catch( Throwable th )
			{
				th.printStackTrace();
				DesktopGenericFunctions.createInstance( null );
				GenericFunctions.instance().getDialogsWrapper().showMessageDialog(DesktopDialogsWrapper.instance().createViewComponent(_parent),
																					"Problem reading configuration: " + th.toString(),
																					"ERROR", DialogsWrapper.ERROR_MESSAGE );
				throw( new RuntimeException( "ERROR while reading configuration" ) );
			}
		}
		return( result );
*/
		return( false );
	}

	public void eraseConfiguration() throws IOException
	{
		GenericFileFunctions.eraseDirCompletely( getFolderName( MAIN_APP_CONF_FOLDER ) );
	}

	protected String getFolderName( String folderNameFromHome )
	{
		return( HOME_FOLDER + FileFunctions.DIR_SEPARATOR + folderNameFromHome );
	}

	protected boolean createOrCopyMainFolder( String oldDir, String newDir ) throws IOException
	{
		boolean imported = false;
		
		if( !FileFunctions.isDirectory( newDir ) && FileFunctions.isDirectory( oldDir ) )
		{
			FileFunctions.copyDirectoryRecursive( oldDir, newDir );
			imported = true;

//			FileFunctions.eraseRecursive( newDir, AboutJDialog.ABOUT_RTF_FILE_NAME );
			FileFunctions.eraseRecursive( newDir, LicenseJDialog.BASE_RTF_FILE_NAME );
		}
		else if( !FileFunctions.isDirectory( newDir ) )
		{
			(new File( newDir ) ).mkdirs();
		}
		
		return( imported );
	}
/*
	protected boolean checkAndImportConfiguration() throws ConfigurationException, IOException
	{

		boolean imported = false;

		String oldDir = HOME_FOLDER + FileFunctions.DIR_SEPARATOR + PREVIOUS_MAIN_APP_CONF_FOLDER;
		String newDir = HOME_FOLDER + FileFunctions.DIR_SEPARATOR + MAIN_APP_CONF_FOLDER;
		imported = createOrCopyMainFolder( oldDir, newDir );

		oldDir = HOME_FOLDER + FileFunctions.DIR_SEPARATOR + PREVIOUS_ENCRYPTION_LIBRARY_CONF_FOLDER;
		newDir = HOME_FOLDER + FileFunctions.DIR_SEPARATOR + ENCRYPTION_LIBRARY_CONF_FOLDER;

		File newDirFile = new File( newDir );
		if( FileFunctions.isDirectory( oldDir ) && !newDirFile.exists() )
		{
			newDirFile.mkdirs();
			_createdEncryptingConfigurations = true;
		}
		*/
/*
		if( checkDirectory( oldDir, newDir ) )
		{
			imported = true;

			_createdEncryptingConfigurations = updateEncryptingConfigurations( newDir );
		}
*/
/*
		return( imported );
	}
*/
/*
	public boolean updateEncryptingConfiguration( String fileName ) throws ConfigurationException
	{
		boolean updated = false;

		EncryptingConfiguration result = new EncryptingConfiguration();
		result.M_openConfiguration( fileName );
	
		int encType = result.M_getIntParamConfiguration( EncryptingConfiguration.STR_CONF_FILE_ENCODER_TYPE );
		if( encType == 2 )
		{
			int newEncType = 4;	// Encoder type 2 has a bug, and in this version has been replaced by Encoder type 4.
			result.M_setIntParamConfiguration( EncryptingConfiguration.STR_CONF_FILE_ENCODER_TYPE, newEncType );

			result.M_saveConfiguration( fileName );
			updated = true;
		}

		return( updated );
	}

	public boolean updateEncryptingConfigurations( String dir ) throws ConfigurationException
	{
		boolean updated = false;
		
		int ii=0;
		
		boolean repeat = true;
		do
		{
			ii++;
			String fileName = EncryptingConfiguration.getFileName( dir, ii );
			repeat = FileFunctions.isFile( fileName );
			if( repeat )
			{
				updated |= updateEncryptingConfiguration( fileName );
			}
		} while( repeat );

		return( updated );
	}
*/

	public final void openBasicConfiguration() throws ConfigurationException
	{
		try
		{
			ApplicationConfiguration.create( Main.getApplicationName() );
			ApplicationConfiguration.instance().M_openConfiguration();

			String[] basicLanguages = new String[]{ "EN" };
			String[] availableLanguagesInJar = new String[]{ "EN" };

			ObtainAvailableLanguages_base.create(basicLanguages, availableLanguagesInJar, ApplicationConfiguration.instance().getDefaultLanguageConfigurationFolder("") );
			DesktopGenericFunctions.createInstance( ApplicationConfiguration.instance() );
		}
		catch( ConfigurationException ce )
		{
			ce.printStackTrace();
			StaticDesktopDialogsWrapper.showMessageDialog(null, ce.getMessage() + " Exiting from application",
											"Configuration error", JOptionPane.ERROR_MESSAGE, null);
			throw( ce );
		}
	}

	public void openOtherConfiguration() throws ConfigurationException
	{
/*
		try
		{
			AppStringsConf.createInstance( ApplicationConfiguration.instance() );
			AppStringsConf.instance().M_openConfiguration();
			AppStringsConf.instance().changeLanguage( ApplicationConfiguration.instance().getLanguage() );
		}
		catch( ConfigurationException ce )
		{
			ce.printStackTrace();
			throw( ce );
		}

		ChessStringsConf chessStrConf = null;
		try
		{
			chessStrConf = ChessStringsConf.createInstance( ApplicationConfiguration.instance() );
			chessStrConf.M_openConfiguration();
			chessStrConf.changeLanguage( ApplicationConfiguration.instance().M_getLanguage() );
		}
		catch( Throwable th )
		{
			th.printStackTrace();
		}
*/
//		StartPDFLib.start( ApplicationConfiguration.instance(), ChessMoveAlgebraicNotation.instance() );
//		WarningsOfEncryptingConfigurations.createInstance( ApplicationConfiguration.instance() );
	}

	
	
}
