/* 
 * Copyright (C) 2017 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.number;

/**
 *
 * @author Usuario
 */
public class IntegerFunctions
{
	public static int max( int i1, int i2 )
	{
		return( i1>i2 ? i1 : i2 );
	}

	public static int min( int i1, int i2 )
	{
		return( i1<i2 ? i1 : i2 );
	}

	public static int abs( int ii )
	{
		return( ii>=0 ? ii : -ii );
	}

	public static int sgn( int ii )
	{
		return( ii>0 ? 1 : ( ii<0 ? -1 : 0 ) );
	}
	
	public static Integer parseInt( String str )
	{
		Integer result = null;

		try
		{
			result = Integer.parseInt(str);
		}
		catch( Throwable th )
		{}

		return( result );
	}
	
	public static boolean isPresentInArray( int value, int[] array )
	{
		boolean result = false;
		
		if( array != null )
		{
			for( int ii=0; (ii<array.length) && !result; ii++ )
				result = (array[ii] == value);
		}
		
		return( result );
	}
}
