/* 
 * Copyright (C) 2017 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.generic;

import com.frojasg1.applications.common.configuration.application.BaseApplicationConfigurationInterface;
import com.frojasg1.general.dialogs.DialogsWrapper;
import com.frojasg1.general.files.GenericFileFacilities;
import com.frojasg1.general.keyboard.GenericKeyboard;
import com.frojasg1.generic.languages.ObtainAvailableLanguages_int;

/**
 *
 * @author Usuario
 */
public class GenericFunctions implements GenericInterface
{
	protected GenericInterface _registeredInterface = null;
	protected static GenericFunctions _instance = null;

	public static GenericFunctions instance()
	{
		if( _instance == null )
			_instance = new GenericFunctions();

		return( _instance );
	}

	public GenericFunctions( )
	{
	}

	public void register( GenericInterface interfaceToRegister )
	{
		_registeredInterface = interfaceToRegister;
	}
	
	@Override
	public BaseApplicationConfigurationInterface getAppliConf()
	{
		if( _registeredInterface == null )
			throw( new RuntimeException( "Before using this function, you must register the particular implmentation of the genericInterface" ) );

		return( _registeredInterface.getAppliConf() );
	}

	@Override
	public DialogsWrapper getDialogsWrapper()
	{
		if( _registeredInterface == null )
			throw( new RuntimeException( "Before using this function, you must register the particular implmentation of the genericInterface" ) );

		return( _registeredInterface.getDialogsWrapper() );
	}

	@Override
	public GenericFileFacilities getFileFacilities()
	{
		if( _registeredInterface == null )
			throw( new RuntimeException( "Before using this function, you must register the particular implmentation of the genericInterface" ) );

		return( _registeredInterface.getFileFacilities() );
	}

	@Override
	public GenericKeyboard getKeyboardFacilities()
	{
		if( _registeredInterface == null )
			throw( new RuntimeException( "Before using this function, you must register the particular implmentation of the genericInterface" ) );

		return( _registeredInterface.getKeyboardFacilities() );
	}

	@Override
	public ObtainAvailableLanguages_int getObtainAvailableLanguages()
	{
		if( _registeredInterface == null )
			throw( new RuntimeException( "Before using this function, you must register the particular implmentation of the genericInterface" ) );

		return( _registeredInterface.getObtainAvailableLanguages() );
	}
}
